"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GGPError = exports.ErrorCode = void 0;
var ErrorCode;
(function (ErrorCode) {
    ErrorCode[ErrorCode["PrevOwnerNotFound"] = 0] = "PrevOwnerNotFound";
    ErrorCode[ErrorCode["LedgerUnknownTopic"] = 1] = "LedgerUnknownTopic";
    ErrorCode[ErrorCode["SqliteConfigNotFound"] = 2] = "SqliteConfigNotFound";
    ErrorCode[ErrorCode["SourceKafkaConfigNotFound"] = 3] = "SourceKafkaConfigNotFound";
    ErrorCode[ErrorCode["SourceKafkaUnexpectedMessage"] = 4] = "SourceKafkaUnexpectedMessage";
    ErrorCode[ErrorCode["InvalidPayload"] = 5] = "InvalidPayload";
    ErrorCode[ErrorCode["VotingConfigNotFound"] = 6] = "VotingConfigNotFound";
})(ErrorCode || (exports.ErrorCode = ErrorCode = {}));
class GGPError extends Error {
    constructor(code, details) {
        super(`GGP node error: ${ErrorCode[code]} (e${code}). Details=${JSON.stringify(details)}`);
    }
}
exports.GGPError = GGPError;
