"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LedgerQuery = void 0;
const input_message_1 = require("../input-message");
const node_1 = require("../node");
const InputMessage = input_message_1.InputMessages.UnitsChanged({});
const LedgerQuery = (api) => class LedgerQuery extends node_1.Node {
    constructor(config) {
        super(api, config, InputMessage);
    }
    onInput(message) {
        const txLog = message.payload.txLog;
        const accountIds = txLog.changes.flatMap((change) => {
            return [change.owner].concat(change.prevOwner ?? []);
        });
        return this.sendBuilder(message)
            .setTopic('get_ledger_entries')
            .addPayload({
            ledgerQuery: accountIds.map(accountId => ({
                accountId,
                rootUnitId: message.payload.txLog.rootUnitId,
            }))
        })
            .sendToOutput(0);
    }
};
exports.LedgerQuery = LedgerQuery;
