import type { Consumer } from 'kafkajs';
import * as z from 'zod';
import type { Api } from '../api';
declare const InputMessage: z.ZodUnion<[z.ZodObject<{
    topic: z.ZodLiteral<"finished-processing">;
    payload: z.ZodObject<{
        kafkaMessageOffset: z.ZodString;
    }, "strip", z.ZodTypeAny, {
        kafkaMessageOffset: string;
    }, {
        kafkaMessageOffset: string;
    }>;
}, "strip", z.ZodTypeAny, {
    topic: "finished-processing";
    payload: {
        kafkaMessageOffset: string;
    };
}, {
    topic: "finished-processing";
    payload: {
        kafkaMessageOffset: string;
    };
}>, z.ZodObject<{
    topic: z.ZodLiteral<"force-reset">;
}, "strip", z.ZodTypeAny, {
    topic: "force-reset";
}, {
    topic: "force-reset";
}>]>;
export declare const SourceKafka: (api: Api) => {
    new (config: any): {
        consumer: Promise<Consumer>;
        /** Used to orchestrate consumer retry */
        isDestroying: boolean;
        kafkaPendingProcessing: {
            messageOffset: string;
            resolve: VoidFunction;
            reject: (err: Error) => void;
        } | null;
        runConsumerWithRetry({ topic }: {
            topic: string;
        }): void;
        runConsumer({ topic }: {
            topic: string;
        }): Promise<void>;
        setStatus(status: 'connected' | 'waiting' | 'connecting'): void;
        /**
         * Input is responsible for resolving promise that kafka consumer is waiting for
         */
        onInput(message: z.infer<typeof InputMessage>): void;
        onDestroy(): Promise<void>;
        api: Api;
        nodeConfig: unknown;
        messageZod: z.ZodUnion<[z.ZodObject<{
            topic: z.ZodLiteral<"finished-processing">;
            payload: z.ZodObject<{
                kafkaMessageOffset: z.ZodString;
            }, "strip", z.ZodTypeAny, {
                kafkaMessageOffset: string;
            }, {
                kafkaMessageOffset: string;
            }>;
        }, "strip", z.ZodTypeAny, {
            topic: "finished-processing";
            payload: {
                kafkaMessageOffset: string;
            };
        }, {
            topic: "finished-processing";
            payload: {
                kafkaMessageOffset: string;
            };
        }>, z.ZodObject<{
            topic: z.ZodLiteral<"force-reset">;
        }, "strip", z.ZodTypeAny, {
            topic: "force-reset";
        }, {
            topic: "force-reset";
        }>]>;
        getBaseUrls(): Promise<{
            kafka_url?: string | string[] | undefined;
            kafka_proxy_url?: string | undefined;
            indexer_url?: string | undefined;
            rpc_url?: string | undefined;
        }>;
        getNodeEnvConfig(): {
            BASE_URL_CDN?: string | undefined;
            EWX_SOLUTION_ID?: string | undefined;
            EWX_SOLUTION_GROUP_ID?: string | undefined;
            EWX_WORKLOGIC_ID?: string | undefined;
            EWX_SQLITE_PATH?: string | undefined;
            EWX_WORKER_ADDRESS?: string | undefined;
        };
        sendBuilder(inputMessage: import("../types").NodeMessage<any>): import("../node").SendBuilder;
        handleMaybePromise<T>(maybePromiseCb: () => T | Promise<T>, done: (err?: Error | undefined) => void): void;
    };
};
export {};
