"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LedgerEntry = exports.TxLog = exports.TxChange = exports.VOTE_REJECT = exports.VOTE_APPROVE = exports.Vote = void 0;
const tslib_1 = require("tslib");
const z = tslib_1.__importStar(require("zod"));
exports.Vote = z.object({
    votingId: z.string(),
    vote: z.string()
});
exports.VOTE_APPROVE = 'approve';
exports.VOTE_REJECT = 'reject';
exports.TxChange = z.object({
    prevOwner: z.string().uuid().nullable(),
    owner: z.string().uuid(),
    volume: z.number(),
    unitId: z.string().uuid(),
});
exports.TxLog = z.object({
    rootUnitId: z.string().uuid(),
    changes: z.array(exports.TxChange),
});
exports.LedgerEntry = z.object({
    accountId: z.string().uuid(),
    rootUnitId: z.string().uuid(),
    volume: z.number(),
});
