import * as z from 'zod';
import type { Api } from '../api';
import { Vote } from '../types';
declare const InputMessage: z.ZodObject<{
    payload: z.ZodObject<{
        voting: z.ZodArray<z.ZodObject<{
            votingId: z.ZodString;
            vote: z.ZodString;
        }, "strip", z.ZodTypeAny, {
            votingId: string;
            vote: string;
        }, {
            votingId: string;
            vote: string;
        }>, "many">;
    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
        voting: z.ZodArray<z.ZodObject<{
            votingId: z.ZodString;
            vote: z.ZodString;
        }, "strip", z.ZodTypeAny, {
            votingId: string;
            vote: string;
        }, {
            votingId: string;
            vote: string;
        }>, "many">;
    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
        voting: z.ZodArray<z.ZodObject<{
            votingId: z.ZodString;
            vote: z.ZodString;
        }, "strip", z.ZodTypeAny, {
            votingId: string;
            vote: string;
        }, {
            votingId: string;
            vote: string;
        }>, "many">;
    }, z.ZodTypeAny, "passthrough">>;
}, "passthrough", z.ZodTypeAny, z.objectOutputType<{
    payload: z.ZodObject<{
        voting: z.ZodArray<z.ZodObject<{
            votingId: z.ZodString;
            vote: z.ZodString;
        }, "strip", z.ZodTypeAny, {
            votingId: string;
            vote: string;
        }, {
            votingId: string;
            vote: string;
        }>, "many">;
    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
        voting: z.ZodArray<z.ZodObject<{
            votingId: z.ZodString;
            vote: z.ZodString;
        }, "strip", z.ZodTypeAny, {
            votingId: string;
            vote: string;
        }, {
            votingId: string;
            vote: string;
        }>, "many">;
    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
        voting: z.ZodArray<z.ZodObject<{
            votingId: z.ZodString;
            vote: z.ZodString;
        }, "strip", z.ZodTypeAny, {
            votingId: string;
            vote: string;
        }, {
            votingId: string;
            vote: string;
        }>, "many">;
    }, z.ZodTypeAny, "passthrough">>;
}, z.ZodTypeAny, "passthrough">, z.objectInputType<{
    payload: z.ZodObject<{
        voting: z.ZodArray<z.ZodObject<{
            votingId: z.ZodString;
            vote: z.ZodString;
        }, "strip", z.ZodTypeAny, {
            votingId: string;
            vote: string;
        }, {
            votingId: string;
            vote: string;
        }>, "many">;
    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
        voting: z.ZodArray<z.ZodObject<{
            votingId: z.ZodString;
            vote: z.ZodString;
        }, "strip", z.ZodTypeAny, {
            votingId: string;
            vote: string;
        }, {
            votingId: string;
            vote: string;
        }>, "many">;
    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
        voting: z.ZodArray<z.ZodObject<{
            votingId: z.ZodString;
            vote: z.ZodString;
        }, "strip", z.ZodTypeAny, {
            votingId: string;
            vote: string;
        }, {
            votingId: string;
            vote: string;
        }>, "many">;
    }, z.ZodTypeAny, "passthrough">>;
}, z.ZodTypeAny, "passthrough">>;
declare const Config: z.ZodObject<{
    indexerUrl: z.ZodString;
    solutionNamespace: z.ZodString;
    workerAddress: z.ZodString;
}, "strip", z.ZodTypeAny, {
    indexerUrl: string;
    solutionNamespace: string;
    workerAddress: string;
}, {
    indexerUrl: string;
    solutionNamespace: string;
    workerAddress: string;
}>;
/** Based on https://github.com/energywebfoundation/node-red-contrib-energywebx/blob/master/submit-solution.js */
export declare const VotingMarketplace: (api: Api) => {
    new (rawConfig: any): {
        config: Promise<z.infer<typeof Config>>;
        onInput(message: z.infer<typeof InputMessage>): Promise<void>;
        sendResult(payload: Vote): Promise<void>;
        api: Api;
        nodeConfig: unknown;
        messageZod: z.ZodObject<{
            payload: z.ZodObject<{
                voting: z.ZodArray<z.ZodObject<{
                    votingId: z.ZodString;
                    vote: z.ZodString;
                }, "strip", z.ZodTypeAny, {
                    votingId: string;
                    vote: string;
                }, {
                    votingId: string;
                    vote: string;
                }>, "many">;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                voting: z.ZodArray<z.ZodObject<{
                    votingId: z.ZodString;
                    vote: z.ZodString;
                }, "strip", z.ZodTypeAny, {
                    votingId: string;
                    vote: string;
                }, {
                    votingId: string;
                    vote: string;
                }>, "many">;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                voting: z.ZodArray<z.ZodObject<{
                    votingId: z.ZodString;
                    vote: z.ZodString;
                }, "strip", z.ZodTypeAny, {
                    votingId: string;
                    vote: string;
                }, {
                    votingId: string;
                    vote: string;
                }>, "many">;
            }, z.ZodTypeAny, "passthrough">>;
        }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
            payload: z.ZodObject<{
                voting: z.ZodArray<z.ZodObject<{
                    votingId: z.ZodString;
                    vote: z.ZodString;
                }, "strip", z.ZodTypeAny, {
                    votingId: string;
                    vote: string;
                }, {
                    votingId: string;
                    vote: string;
                }>, "many">;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                voting: z.ZodArray<z.ZodObject<{
                    votingId: z.ZodString;
                    vote: z.ZodString;
                }, "strip", z.ZodTypeAny, {
                    votingId: string;
                    vote: string;
                }, {
                    votingId: string;
                    vote: string;
                }>, "many">;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                voting: z.ZodArray<z.ZodObject<{
                    votingId: z.ZodString;
                    vote: z.ZodString;
                }, "strip", z.ZodTypeAny, {
                    votingId: string;
                    vote: string;
                }, {
                    votingId: string;
                    vote: string;
                }>, "many">;
            }, z.ZodTypeAny, "passthrough">>;
        }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
            payload: z.ZodObject<{
                voting: z.ZodArray<z.ZodObject<{
                    votingId: z.ZodString;
                    vote: z.ZodString;
                }, "strip", z.ZodTypeAny, {
                    votingId: string;
                    vote: string;
                }, {
                    votingId: string;
                    vote: string;
                }>, "many">;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                voting: z.ZodArray<z.ZodObject<{
                    votingId: z.ZodString;
                    vote: z.ZodString;
                }, "strip", z.ZodTypeAny, {
                    votingId: string;
                    vote: string;
                }, {
                    votingId: string;
                    vote: string;
                }>, "many">;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                voting: z.ZodArray<z.ZodObject<{
                    votingId: z.ZodString;
                    vote: z.ZodString;
                }, "strip", z.ZodTypeAny, {
                    votingId: string;
                    vote: string;
                }, {
                    votingId: string;
                    vote: string;
                }>, "many">;
            }, z.ZodTypeAny, "passthrough">>;
        }, z.ZodTypeAny, "passthrough">>;
        getBaseUrls(): Promise<{
            kafka_url?: string | string[] | undefined;
            kafka_proxy_url?: string | undefined;
            indexer_url?: string | undefined;
            rpc_url?: string | undefined;
        }>;
        getNodeEnvConfig(): {
            BASE_URL_CDN?: string | undefined;
            EWX_SOLUTION_ID?: string | undefined;
            EWX_SOLUTION_GROUP_ID?: string | undefined;
            EWX_WORKLOGIC_ID?: string | undefined;
            EWX_SQLITE_PATH?: string | undefined;
            EWX_WORKER_ADDRESS?: string | undefined;
        };
        sendBuilder(inputMessage: import("../types").NodeMessage<any>): import("../node").SendBuilder;
        onDestroy?(): void | Promise<void>;
        handleMaybePromise<T>(maybePromiseCb: () => T | Promise<T>, done: (err?: Error | undefined) => void): void;
    };
};
export {};
