import * as z from 'zod';
import type { Api } from '../api';
import type { Config as VotingConfig } from '../voting-service-config/voting-service-config.node';
declare const InputMessage: z.ZodObject<{
    payload: z.ZodObject<{
        voting: z.ZodArray<z.ZodObject<{
            votingId: z.ZodString;
            vote: z.ZodString;
        }, "strip", z.ZodTypeAny, {
            votingId: string;
            vote: string;
        }, {
            votingId: string;
            vote: string;
        }>, "many">;
    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
        voting: z.ZodArray<z.ZodObject<{
            votingId: z.ZodString;
            vote: z.ZodString;
        }, "strip", z.ZodTypeAny, {
            votingId: string;
            vote: string;
        }, {
            votingId: string;
            vote: string;
        }>, "many">;
    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
        voting: z.ZodArray<z.ZodObject<{
            votingId: z.ZodString;
            vote: z.ZodString;
        }, "strip", z.ZodTypeAny, {
            votingId: string;
            vote: string;
        }, {
            votingId: string;
            vote: string;
        }>, "many">;
    }, z.ZodTypeAny, "passthrough">>;
}, "passthrough", z.ZodTypeAny, z.objectOutputType<{
    payload: z.ZodObject<{
        voting: z.ZodArray<z.ZodObject<{
            votingId: z.ZodString;
            vote: z.ZodString;
        }, "strip", z.ZodTypeAny, {
            votingId: string;
            vote: string;
        }, {
            votingId: string;
            vote: string;
        }>, "many">;
    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
        voting: z.ZodArray<z.ZodObject<{
            votingId: z.ZodString;
            vote: z.ZodString;
        }, "strip", z.ZodTypeAny, {
            votingId: string;
            vote: string;
        }, {
            votingId: string;
            vote: string;
        }>, "many">;
    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
        voting: z.ZodArray<z.ZodObject<{
            votingId: z.ZodString;
            vote: z.ZodString;
        }, "strip", z.ZodTypeAny, {
            votingId: string;
            vote: string;
        }, {
            votingId: string;
            vote: string;
        }>, "many">;
    }, z.ZodTypeAny, "passthrough">>;
}, z.ZodTypeAny, "passthrough">, z.objectInputType<{
    payload: z.ZodObject<{
        voting: z.ZodArray<z.ZodObject<{
            votingId: z.ZodString;
            vote: z.ZodString;
        }, "strip", z.ZodTypeAny, {
            votingId: string;
            vote: string;
        }, {
            votingId: string;
            vote: string;
        }>, "many">;
    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
        voting: z.ZodArray<z.ZodObject<{
            votingId: z.ZodString;
            vote: z.ZodString;
        }, "strip", z.ZodTypeAny, {
            votingId: string;
            vote: string;
        }, {
            votingId: string;
            vote: string;
        }>, "many">;
    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
        voting: z.ZodArray<z.ZodObject<{
            votingId: z.ZodString;
            vote: z.ZodString;
        }, "strip", z.ZodTypeAny, {
            votingId: string;
            vote: string;
        }, {
            votingId: string;
            vote: string;
        }>, "many">;
    }, z.ZodTypeAny, "passthrough">>;
}, z.ZodTypeAny, "passthrough">>;
export declare const VotingService: (api: Api) => {
    new (rawConfig: unknown): {
        votingConfig: Promise<z.infer<typeof VotingConfig>>;
        onInput(message: z.infer<typeof InputMessage>): Promise<void>;
        api: Api;
        nodeConfig: unknown;
        messageZod: z.ZodObject<{
            payload: z.ZodObject<{
                voting: z.ZodArray<z.ZodObject<{
                    votingId: z.ZodString;
                    vote: z.ZodString;
                }, "strip", z.ZodTypeAny, {
                    votingId: string;
                    vote: string;
                }, {
                    votingId: string;
                    vote: string;
                }>, "many">;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                voting: z.ZodArray<z.ZodObject<{
                    votingId: z.ZodString;
                    vote: z.ZodString;
                }, "strip", z.ZodTypeAny, {
                    votingId: string;
                    vote: string;
                }, {
                    votingId: string;
                    vote: string;
                }>, "many">;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                voting: z.ZodArray<z.ZodObject<{
                    votingId: z.ZodString;
                    vote: z.ZodString;
                }, "strip", z.ZodTypeAny, {
                    votingId: string;
                    vote: string;
                }, {
                    votingId: string;
                    vote: string;
                }>, "many">;
            }, z.ZodTypeAny, "passthrough">>;
        }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
            payload: z.ZodObject<{
                voting: z.ZodArray<z.ZodObject<{
                    votingId: z.ZodString;
                    vote: z.ZodString;
                }, "strip", z.ZodTypeAny, {
                    votingId: string;
                    vote: string;
                }, {
                    votingId: string;
                    vote: string;
                }>, "many">;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                voting: z.ZodArray<z.ZodObject<{
                    votingId: z.ZodString;
                    vote: z.ZodString;
                }, "strip", z.ZodTypeAny, {
                    votingId: string;
                    vote: string;
                }, {
                    votingId: string;
                    vote: string;
                }>, "many">;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                voting: z.ZodArray<z.ZodObject<{
                    votingId: z.ZodString;
                    vote: z.ZodString;
                }, "strip", z.ZodTypeAny, {
                    votingId: string;
                    vote: string;
                }, {
                    votingId: string;
                    vote: string;
                }>, "many">;
            }, z.ZodTypeAny, "passthrough">>;
        }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
            payload: z.ZodObject<{
                voting: z.ZodArray<z.ZodObject<{
                    votingId: z.ZodString;
                    vote: z.ZodString;
                }, "strip", z.ZodTypeAny, {
                    votingId: string;
                    vote: string;
                }, {
                    votingId: string;
                    vote: string;
                }>, "many">;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                voting: z.ZodArray<z.ZodObject<{
                    votingId: z.ZodString;
                    vote: z.ZodString;
                }, "strip", z.ZodTypeAny, {
                    votingId: string;
                    vote: string;
                }, {
                    votingId: string;
                    vote: string;
                }>, "many">;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                voting: z.ZodArray<z.ZodObject<{
                    votingId: z.ZodString;
                    vote: z.ZodString;
                }, "strip", z.ZodTypeAny, {
                    votingId: string;
                    vote: string;
                }, {
                    votingId: string;
                    vote: string;
                }>, "many">;
            }, z.ZodTypeAny, "passthrough">>;
        }, z.ZodTypeAny, "passthrough">>;
        getBaseUrls(): Promise<{
            kafka_url?: string | string[] | undefined;
            kafka_proxy_url?: string | undefined;
            indexer_url?: string | undefined;
            rpc_url?: string | undefined;
        }>;
        getNodeEnvConfig(): {
            BASE_URL_CDN?: string | undefined;
            EWX_SOLUTION_ID?: string | undefined;
            EWX_SOLUTION_GROUP_ID?: string | undefined;
            EWX_WORKLOGIC_ID?: string | undefined;
            EWX_SQLITE_PATH?: string | undefined;
            EWX_WORKER_ADDRESS?: string | undefined;
        };
        sendBuilder(inputMessage: import("../types").NodeMessage<any>): import("../node").SendBuilder;
        onDestroy?(): void | Promise<void>;
        handleMaybePromise<T>(maybePromiseCb: () => T | Promise<T>, done: (err?: Error | undefined) => void): void;
    };
};
export {};
